@MISC{ebpf,
key = {{ebpf}},
title = {{eBPF (extened Binary Packet Filter)}},
note = {
\url{http://prototype-kernel.readthedocs.io/en/latest/bpf/}
},
language = {english},
}
   
@MISC{tofino,
	key = {{Tofino}},
	title = {{Barefoot Tofino}},
	note = {
	\url{https://barefootnetworks.com/products/brief-tofino/}
	},
	language = {english},
}

@MISC{CiscoNCS5500,
	key = {{Cisco NCS 5500 Modular Platform Architecture}},
	title = {{Cisco NCS 5500 Modular Platform Architecture}},
	note = {
	\url{https://www.cisco.com/c/dam/en/us/products/collateral/routers/network-convergence-system-5500-series/ncs5500-modular-platform-architecture-white-paper.pdf}
	},
	language = {english},
}

@MISC{attcorerouter,
	key = {{AT\&T is First in Industry to Deploy Open Dis-Aggregated Core Router}},
	title = {{AT\&T is First in Industry to Deploy Open Dis-Aggregated Core Router}},
	note = {
	\url{https://about.att.com/story/2020/open_disaggregated_core_router.html}
	},
	language = {english},
}

@MISC{SiliconOne,
	key = {{Cisco Silicon One}},
	title = {{Cisco Silicon One}},
	note = {
	\url{https://www.cisco.com/c/en/us/products/collateral/routers/8000-series-routers/datasheet-c78-742571.html}
	},
	language = {english},
}

@MISC{Yosys,
	author = {Clifford Wolf},
	title = {Yosys Open SYnthesis Suite},
	howpublished = "\url{http://www.clifford.at/yosys/}"
}

@article{wolfyosys,
	title={{Yosys manual}},
	author={Wolf, Clifford}
}

 

@MISC{tsc,
	key = {{CPU performance couter (TSC register)}},
	title = {{CPU performance couter (TSC register)}},
	note = {
	\url{https://en.wikipedia.org/wiki/Time_Stamp_Counter}
	},
	language = {english},
}

@MISC{aladdinpowermodel,
	key = {{Timing, Power and Area of OpenPDK 45nm mixed cell library}},
	title = {{Timing, Power and Area of OpenPDK 45nm mixed cell library}},
	note = {
	\url{https://github.com/ysshao/ALADDIN/blob/master/common/power_func.h}
	},
	language = {english},
}

@MISC{cumulus,
	key = {{Cumulus Network}},
	title = {{Cumulus Network}},
	note = {
	\url{https://cumulusnetworks.com/}
	},
	language = {english},
}

@MISC{FreePDK,
	key = {{FreePDK}},
	title = {{FreePDK}},
	note = {
	\url{https://www.eda.ncsu.edu/wiki/FreePDK}
	},
	language = {english},
}

@MISC{xplaint,
	key = {{xplaint}},
	title = {{Cavium XPliant}},
	note = {
	\url{http://www.cavium.com/pdfFiles/CNX880XX_PB_Rev1.pdf}
	},
	language = {english},
}

@MISC{Jericho2,
	key = {{Jericho2}},
	title = {{Brodcom Jericho2}},
	note = {
	\url{https://www.broadcom.com/news/product-releases/broadcom-ships-jericho2}
	},
	language = {english},
}

@MISC{ripe,
key = {{RIPE Network Coordination Centre}},
title = {{RIPE Network Coordination Centre}},
note = {
\url{https://www.ripe.net/}
},
language = {english},
}

@MISC{routeviews,
key = {{Route Views Project}},
title = {{Route Views Project}},
note = {
\url{http://www.routeviews.org/routeviews/}
},
language = {english},
}

@MISC{wide-mawi,
	key = {{WIDE Project MAWI Working Group Traffic Archive}},
	title = {{WIDE Project MAWI Working Group Traffic Archive}},
	note = {
	\url{http://mawi.wide.ad.jp/mawi/}
	},
	language = {english},
}
   
@MISC{caida,
key = {{CAIDA Anonymized Internet Trace}},
title = {{CAIDA Anonymized Internet Trace}},
note = {
\url{https://www.caida.org}
},
language = {english},
}

@MISC{bgpreport,
key = {{BGP Report}},
title = {{BGP Report}},
note = {
\url{http://bgp.potaroo.net/}
},
language = {english},
}
  
@MISC{x86instructions,
key = {{x86 Instruction Set Reference}},
title = {{x86 Instruction Set Reference}},
note = {
\url{https://c9x.me/x86/}
},
language = {english},
}

@inproceedings{vanjacobson,
author = "Van Jacobson and Michael J. Karels",
title = "Congestion Avoidance and Control",
booktitle = "SIGCOMM 1988",
address = "Stanford, CA",
month = aug,
year = 1988
}

@inproceedings{yang2014guarantee,
title={{Guarantee IP lookup performance with FIB explosion}},
author={Yang, Tong and Xie, Gaogang and Li, YanBiao and Fu, Qiaobin and Liu, Alex X and Li, Qi and Mathy, Laurent},
booktitle={ACM SIGCOMM 2014},
}

@inproceedings{waldvogel1997scalable,
	title={{Scalable high speed IP routing lookups}},
	author={Waldvogel, Marcel and Varghese, George and Turner, Jon and Plattner, Bernhard},
	booktitle={ACM SIGCOMM},
	pages={25--36},
	year={1997}
}

@inproceedings{broder2001using,
	title={{Using multiple hash functions to improve IP lookups}},
	author={Broder, Andrei and Mitzenmacher, Michael},
	booktitle={IEEE INFOCOM},
	volume={3},
	pages={1454--1463},
	year={2001}
}

@article{pong2009suse,
	title={{SUSE: Superior storage-efficiency for routing tables through prefix transformation and aggregation}},
	author={Pong, Fong and Tzeng, Nian-Feng},
	journal={IEEE/ACM Transactions on Networking},
	volume={18},
	number={1},
	pages={81--94},
	year={2009}
}

@article{pong2011concise,
	title={{Concise lookup tables for IPv4 and IPv6 longest prefix matching in scalable routers}},
	author={Pong, Fong and Tzeng, Nian-Feng},
	journal={IEEE/ACM Transactions on Networking},
	volume={20},
	number={3},
	pages={729--741},
	year={2011}
}
 
@inproceedings{asai2015poptrie,
title={{Poptrie: A compressed trie with population count for fast and scalable software IP routing table lookup}},
author={Asai, Hirochika and Ohara, Yasuhiro},
booktitle={ACM SIGCOMM 2015},
} 
 
@article{nilsson1999ip,
title={{IP-address lookup using LC-tries}},
author={Nilsson, Stefan and Karlsson, Gunnar},
journal={IEEE Journal on selected Areas in Communications},
volume={17},
number={6},
pages={1083--1092},
year={1999},
}

@inproceedings{yu2009hash,
	title={{A hash-based scalable IP lookup using Bloom and fingerprint filters}},
	author={Yu, Heeyeol and Mahapatra, Rabi and Bhuyan, Laxmi},
	booktitle={IEEE ICNP},
	pages={264--273},
	year={2009}
}
 
@inproceedings{gallenmuller2015comparison,
title={{Comparison of frameworks for high-performance packet IO}},
author={Gallenm{\"u}ller, Sebastian and Emmerich, Paul and Wohlfart, Florian and Raumer, Daniel and Carle, Georg},
booktitle={ACM/IEEE ANCS},
year={2015}
}

 
@inproceedings{ancskeynote,
	title={{The Forwarding Plane: An Old New Frontier of Networking Research}},
	author={Changhoon Kim,},
	booktitle={Keynotes at ACM SOSR and ACM/IEEE ANCS},
	year={2018}
}


@inproceedings{zhou2013scalable,
title={{Scalable, high performance ethernet forwarding with CuckooSwitch}},
author={Zhou, Dong and Fan, Bin and Lim, Hyeontaek and Kaminsky, Michael and Andersen, David G},
booktitle=ACM CoNEXT},
pages={97--108},
year={2013}
}

  
@inproceedings{fu2006performance,
title={{Performance evaluation and cache behavior of LC-trie for IP-address lookup}},
author={Fu, Jing and Hagsand, Olof and Karlsson, Gunnar},
booktitle={IEEE HPSR},
pages={7--pp},
year={2006},
}
 
@article{zec2012dxr,
title={{DXR: towards a billion routing lookups per second in software}},
author={Zec, Marko and Rizzo, Luigi and Mikuc, Miljenko},
journal={ACM SIGCOMM Computer Communication Review},
volume={42},
number={5},
pages={29--36},
year={2012},
}

@inproceedings{uzmi2011smalta,
	title={{SMALTA: practical and near-optimal FIB aggregation}},
	author={Uzmi, Zartash Afzal and Nebel, Markus and Tariq, Ahsan and Jawad, Sana and Chen, Ruichuan and Shaikh, Aman and Wang, Jia and Francis, Paul},
	booktitle={ACM CoNEXT},
	pages={1--12},
	year={2011}
}

@inproceedings{islam2019sail,
	title={{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}},
	author={Islam, MD Iftakharul and Khan, Javed I},
	booktitle={IEEE HPSR},
	pages={1--8},
	year={2019}
}

@inproceedings{retvari2013compressing,
title={{Compressing IP forwarding tables: towards entropy bounds and beyond}},
author={R{\'e}tv{\'a}ri, G{\'a}bor and Tapolcai, J{\'a}nos and K{\H{o}}r{\"o}si, Attila and Majd{\'a}n, Andr{\'a}s and Heszberger, Zal{\'a}n},
booktitle={ACM SIGCOMM Computer Communication Review},
volume={43},
number={4},
pages={111--122},
year={2013}
}

@inproceedings{huang2011offset,
	title={{Offset addressing approach to memory-efficient IP address lookup}},
	author={Huang, Kun and Xie, Gaogang and Li, Yanbiao and Liu, Alex X},
	booktitle={IEEE INFOCOM},
	pages={306--310},
	year={2011}
}
 
@inproceedings{song2009scalable,
	title={{Scalable IP lookups using shape graphs}},
	author={Song, Haoyu and Kodialam, Murali and Hao, Fang and Lakshman, TV},
	booktitle={IEEE ICNP},
	pages={73--82},
	year={2009}
}

@inproceedings{pongracz2013cheap,
title={{Cheap silicon: a myth or reality? picking the right data plane hardware for software defined networking}},
author={Pongr{\'a}cz, Gergely and Moln{\'a}r, L{\'a}szl{\'o} and Kis, Zolt{\'a}n Lajos and Tur{\'a}nyi, Zolt{\'a}n},
booktitle={ACM SIGCOMM workshop on Hot topics in Software Defined Networking},
pages={103--108},
year={2013},
}


@MISC{dpdk,
key = {{dpdk}},
title = {{Data Plane Development Kit (DPDK)}},
note = {
\url{http://dpdk.org/}
},
language = {english},
} 
 
@MISC{fibbackbone,
key = {{Routing tables of backbone routers}},
title = {{Routing tables of backbone routers}},
note = {
\url{https://github.com/tamimcse/parse-bgpdump/}
},
language = {english},
}

@MISC{icc,
	key = {{Synopsys Fusion Compiler}},
	title = {{Synopsys Fusion Compiler}},
	note = {
	\url{https://www.synopsys.com/implementation-and-signoff/physical-implementation/fusion-compiler.html}
	},
	language = {english},
}

@MISC{innovus,
	key = {{Cadence Innovus}},
	title = {{Cadence Innovus}},
	note = {
	\url{https://www.cadence.com/en_US/home/tools/digital-design-and-signoff/soc-implementation-and-floorplanning/innovus-implementation-system.html}
	},
	language = {english},
}


@MISC{veriloator,
	key = {{Verilator}},
	title = {{Verilator}},
	note = {
	\url{https://www.veripool.org/wiki/verilator}
	},
	language = {english},
}

@MISC{vivado,
	key = {{Xilinx Vivado SDK}},
	title = {{Xilinx Vivado SDK}},
	note = {
	\url{https://www.xilinx.com/products/design-tools/vivado.html}
	},
	language = {english},
}

@MISC{strutus,
	key = {{Cadence Stratus HLS}},
	title = {{Cadence Stratus HLS}},
	note = {
	\url{https://www.cadence.com/en_US/home/tools/digital-design-and-signoff/synthesis/stratus-high-level-synthesis.html}
	},
	language = {english},
}

@incollection{wakabayashi2008all,
	title={{All-in-C: Behavioral Synthesis and Verification with CyberWorkBench}},
	author={Wakabayashi, Kazutoshi and Schafer, Benjamin Carrion},
	booktitle={High-Level Synthesis},
	pages={113--127},
	year={2008},
	publisher={Springer}
}

@MISC{dolphin-memorycompiler,
	key = {{Dolphin Technology's Memory compiler}},
	title = {{Dolphin Technology's Memory compiler}},
	note = {
	\url{http://www.dolphin-ic.com/memory-products.html}
	},
	language = {english},
}

@MISC{sailpatch,
key = {{SAIL-BM implementation in Linux kernel}},
title = {{SAIL-BM implementation in Linux kernel (patch)}},
note = {
\url{https://github.com/tamimcse/kernel-patches/blob/master/xdp-sail.patch/}
},
language = {english},
}

@MISC{saillpatch,
key = {{SAIL-L implementation in Linux kernel}},
title = {{SAIL-L implementation in Linux kernel (patch)}},
note = {
\url{https://github.com/tamimcse/kernel-patches/blob/master/sail-l.patch/}
},
language = {english},
}

@MISC{saildomino,
key = {{Implementation of SAIL-BM using Domino}},
title = {{Implementation of SAIL-BM using Domino}},
note = {
\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-bm.c}
}

@MISC{sailldomino,
key = {{Implementation of SAIL-L using Domino}},
title = {{Implementation of SAIL-L using Domino}},
note = {
\url{https://github.com/tamimcse/domino-examples/blob/master/domino-programs/sail-l.c}
}

@MISC{sailpipiline,
key = {{SAIL-BM Pipeline}},
title = {{SAIL-BM Pipeline}},
note = {
\url{https://raw.githubusercontent.com/tamimcse/domino-examples/master/pipeline-sail-bm.png},
}

@MISC{vpp,
key = {{vpp}},
title = {{Vector Packet Processing (VPP)}},
note = {
\url{https://wiki.fd.io/view/VPP}
},
language = {english},
}


@MISC{odp,
key = {{odp}},
title = {{OpenDataPlane(ODP)}},
note = {
\url{https://www.opendataplane.org/}
},
language = {english},
} 

@MISC{xdp,
key = {{XDP}},
title = {{XDP (eXpress Data path)}},
note = {
\url{http://prototype-kernel.readthedocs.io/en/latest/networking/XDP/introduction.html}
},
language = {english},
}

@inproceedings{hoiland2018express,
title={{The eXpress Data Path: Fast Programmable Packet Processing in the Operating System Kernel}},
author={H{\o}iland-J{\o}rgensen, Toke and Brouer, Jesper Dangaard and Borkmann, Daniel and Fastabend, John and Herbert, Tom and Ahern, David and Miller, David},
booktitle={ACM CoNEXT},
year={2018},
}


@book{warren2013hacker,
title={{Hacker's delight}},
author={Warren, Henry S},
year={2013},
publisher={Pearson Education}
}
 
@article{fog2011instruction,
title={{Instruction tables: Lists of instruction latencies, throughputs and micro-operation breakdowns for Intel, AMD and VIA CPUs}},
author={Fog, Agner and others},
journal={Copenhagen University College of Engineering},
volume={97},
pages={114},
year={2011}
}
 

@article{guide2011intel,
title={{Intel{\textregistered} 64 and IA-32 Architectures Software Developer’s Manual}},
author={Guide, Part},
journal={Volume 3B: System programming Guide, Part},
volume={2},
year={2011}
}
 
@inproceedings{keutzer2002asic,
title={From ASIC to ASIP: The next design discontinuity},
author={Keutzer, Kurt and Malik, Sharad and Newton, A Richard},
booktitle={IEEE International Conference on Computer Design: VLSI in Computers and Processors},
pages={84--90},
year={2002}
}
 
 
@inproceedings{shao2014aladdin,
title={{Aladdin: A pre-rtl, power-performance accelerator simulator enabling large design space exploration of customized architectures}},
author={Shao, Yakun Sophia and Reagen, Brandon and Wei, Gu-Yeon and Brooks, David},
booktitle={ACM/IEEE ISCA},
volume={42},
number={3},
pages={97--108},
year={2014}
}

@inproceedings{shao2013isa,
title={{ISA-independent workload characterization and its implications for specialized architectures}},
author={Shao, Yakun Sophia and Brooks, David},
booktitle={IEEE International Symposium on Performance Analysis of Systems and Software (ISPASS)},
pages={245--255},
year={2013}
}

@book{book2010mentor,
title={{High-level synthesis: blue book}},
author={Fingeroff, Michael},
year={2010},
publisher={Mentor Graphics Corporation}
}


@inproceedings{kim2013swsl,
title={{SWSL: software synthesis for network lookup}},
author={Kim, Sung Jin and De Carli, Lorenzo and Sankaralingam, Karthikeyan and Estan, Cristian},
booktitle={ACM/IEEE ANCS},
pages={191--202},
year={2013}
}

@inproceedings{harris2012leap,
title={{LEAP: Latency-energy-and area-optimized lookup pipeline}},
author={Harris, Eric N and Wasmundt, Samuel L and De Carli, Lorenzo and Sankaralingam, Karthikeyan and Estan, Cristian},
booktitle={ACM/IEEE ANCS},
pages={175--186},
year={2012},
organization={ACM}
}
 
@inproceedings{de2009plug,
title={{PLUG: flexible lookup modules for rapid deployment of new protocols in high-speed routers}},
author={De Carli, Lorenzo and Pan, Yi and Kumar, Amit and Estan, Cristian and Sankaralingam, Karthikeyan},
booktitle={ACM SIGCOMM},
pages={207--218},
year={2009}
}

@inproceedings{pilato2013bambu,
title={{Bambu: A modular framework for the high level synthesis of memory-intensive applications}},
author={Pilato, Christian and Ferrandi, Fabrizio},
booktitle={IEEE FPL},
pages={1--4},
year={2013}
}

@inproceedings{canis2011legup,
title={{LegUp: high-level synthesis for FPGA-based processor/accelerator systems}},
author={Canis, Andrew and Choi, Jongsok and Aldham, Mark and Zhang, Victor and Kammoona, Ahmed and Anderson, Jason H and Brown, Stephen and Czajkowski, Tomasz},
booktitle={ACM FPGA},
pages={33--36},
year={2011}
}
 
@article{chen2005xpilot,
title={{xPilot: A platform-based behavioral synthesis system}},
author={Chen, Deming and Cong, Jason and Fan, Yiping and Han, Guoling and Jiang, Wei and Zhang, Zhiru},
journal={SRC TechCon},
volume={5},
year={2005}
}

@article{cong2011high,
title={{High-level synthesis for FPGAs: From prototyping to deployment}},
author={Cong, Jason and Liu, Bin and Neuendorffer, Stephen and Noguera, Juanjo and Vissers, Kees and Zhang, Zhiru},
journal={IEEE Transactions on Computer-Aided Design of Integrated Circuits and Systems},
volume={30},
number={4},
pages={473--491},
year={2011}
}
   
@book{elliott1999understanding,
title={{Understanding behavioral synthesis: a practical guide to high-level design}},
author={Elliott, John P},
year={1999},
publisher={Springer Science \& Business Media}
}
 
@book{book2010mentor,
	title={{High-level synthesis: blue book}},
	author={Fingeroff, Michael},
	year={2010},
	publisher={Xlibris Corporation}
}

@article{zilberman2014netfpga,
title={{NetFPGA SUME: Toward 100 Gbps as research commodity}},
author={Zilberman, Noa and Audzevich, Yury and Covington, G Adam and Moore, Andrew W},
journal={IEEE micro},
volume={34},
number={5},
pages={32--41},
year={2014}
}

@inproceedings{li2011cacti,
title={{CACTI-P: Architecture-level modeling for SRAM-based structures with advanced leakage reduction techniques}},
author={Li, Sheng and Chen, Ke and Ahn, Jung Ho and Brockman, Jay B and Jouppi, Norman P},
booktitle={ACM/IEEE ICCAD},
pages={694--701},
year={2011}
} 
  
@inproceedings{ajayi2019toward,
title={{Toward an open-source digital flow: First learnings from the OpenROAD project}},
author={Ajayi, Tutu and Chhabria, Vidya A and Foga{\c{c}}a, Mateus and Hashemi, Soheil and Hosny, Abdelrahman and Kahng, Andrew B and Kim, Minsoo and Lee, Jeongsup and Mallappa, Uday and Neseem, Marina and others},
booktitle={ACM/IEEE DAC},
pages={1--4},
year={2019}
} 

@book{kahng2011vlsi,
title={{VLSI physical design: from graph partitioning to timing closure}},
author={Kahng, Andrew B and Lienig, Jens and Markov, Igor L and Hu, Jin},
year={2011},
publisher={Springer Science \& Business Media}
}
  
@phdthesis{ciccardi2019intelligent,
	title={{Intelligent Scheduler for Heterogeneous System on Chip}},
	author={Ciccardi, Andrea},
	year={2019}
}
  
@inproceedings{guthaus2016openram,
title={{OpenRAM: An open-source memory compiler}},
author={Guthaus, Matthew R and Stine, James E and Ataei, Samira and Chen, Brian and Wu, Bin and Sarwar, Mehedi},
booktitle={IEEE/ACM ICCAD},
pages={1--6},
year={2016}
}

@inproceedings{ataei2017high,
title={{A high performance multi-port SRAM for low voltage shared memory systems in 32 nm CMOS}},
author={Ataei, Samira and Gaalswyk, Matthew and Stine, James E},
booktitle={IEEE 60th International Midwest Symposium on Circuits and Systems (MWSCAS)},
pages={1236--1239},
year={2017}
}

@inproceedings{nichols2019automated,
title={{Automated Synthesis of Multi-Port Memories and Control}},
author={Nichols, Hunter and Grimes, Michael and Sowash, Jennifer and Cirimelli-Low, Jesse and Guthaus, Matthew R},
booktitle={IFIP/IEEE 27th International Conference on Very Large Scale Integration (VLSI-SoC)},
pages={59--64},
year={2019}
}

@inproceedings{ming2012efficient,
title={{An efficient and flexible embedded memory IP compiler}},
author={Ming, Chen and Na, Bai},
booktitle={IEEE International Conference on Cyber-Enabled Distributed Computing and Knowledge Discovery},
pages={268--273},
year={2012}
}

@inproceedings{ataei2019amc,
title={{AMC: An asynchronous memory compiler}},
author={Ataei, Samira and Manohar, Rajit},
booktitle={IEEE ASYNC},
pages={1--8},
year={2019}
}

@inproceedings{goldman2014synopsys,
title={{Synopsys' educational generic memory compiler}},
author={Goldman, R and Bartleson, K and Wood, T and Melikyan, V and Babayan, E},
booktitle={IEEE European Workshop on Microelectronics Education (EWME)},
pages={89--92},
year={2014}
}
 
@inproceedings{ramanarayanan20082,
title={{A 2.1 ghz 6.5 mw 64-bit unified popcount/bitscan datapath unit for 65nm high-performance microprocessor execution cores}},
author={Ramanarayanan, Rajaraman and Mathew, Sanu and Erraguntla, Vasantha and Krishnamurthy, Ram and Gueron, Shay},
booktitle={IEEE International Conference on VLSI Design},
pages={273--278},
year={2008}
}
    
@inproceedings{sivaraman2016packet,
title={{Packet transactions: High-level programming for line-rate switches}},
author={Sivaraman, Anirudh and Cheung, Alvin and Budiu, Mihai and Kim, Changhoon and Alizadeh, Mohammad and Balakrishnan, Hari and Varghese, George and McKeown, Nick and Licking, Steve},
booktitle={ACM SIGCOMM},
pages={15--28},
year={2016}
}
 
@article{bosshart2013forwarding,
title={{Forwarding metamorphosis: Fast programmable match-action processing in hardware for SDN}},
author={Bosshart, Pat and Gibb, Glen and Kim, Hun-Seok and Varghese, George and McKeown, Nick and Izzard, Martin and Mujica, Fernando and Horowitz, Mark},
journal={ACM SIGCOMM},
volume={43},
number={4},
pages={99--110},
year={2013}
}

@inproceedings{choi2018fboss,
title={{FBOSS: building switch software at scale}},
author={Choi, Sean and Burkov, Boris and Eckert, Alex and Fang, Tian and Kazemkhani, Saman and Sherwood, Rob and Zhang, Ying and Zeng, Hongyi},
booktitle={ACM SIGCOMM},
pages={342--356},
year={2018}
}

@inproceedings{gibb2013design,
title={Design principles for packet parsers},
author={Gibb, Glen and Varghese, George and Horowitz, Mark and McKeown, Nick},
booktitle={ACM/IEEE ANCS},
pages={13--24},
year={2013},
}


@inproceedings{tamimsail,
title={{SAIL Based FIB Lookup in a Programmable Pipeline Based Linux Router}},
author={Islam, Md Iftakharul and Khan, Javed I},
booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
year={2019}
}
 
@inproceedings{tamimrcp,
title={{Leveraging Domino to Implement RCP in a Stateful Programmable Pipeline}},
author={Islam, Md Iftakharul and Khan, Javed I},
booktitle={IEEE International Conference on High Performance Switching and Routing (HPSR)},
year={2019}
}

@inproceedings{narayana2017language,
title={Language-directed hardware design for network performance monitoring},
author={Narayana, Srinivas and Sivaraman, Anirudh and Nathan, Vikram and Goyal, Prateesh and Arun, Venkat and Alizadeh, Mohammad and Jeyakumar, Vimalkumar and Kim, Changhoon},
booktitle={ACM SIGCOMM},
pages={85--98},
year={2017}
}

 
#TCAM
@inproceedings{mcauley1993fast,
title={{Fast routing table lookup using CAMs}},
author={McAuley, Anthony J and Francis, Paul},
booktitle={IEEE INFOCOM},
volume={93},
pages={1382--1391},
year={1993},
}
 
@inproceedings{zane2003coolcams,
title={{CoolCAMs: Power-efficient TCAMs for forwarding engines}},
author={Zane, Francis and Narlikar, Girija and Basu, Anindya},
booktitle={IEEE INFOCOM},
volume={1},
pages={42--52},
year={2003},
}

@article{zheng2006tcam,
title={{A TCAM-based distributed parallel IP lookup scheme and performance analysis}},
author={Zheng, Kai and Hu, Chengchen and Lu, Hongbin and Liu, Bin},
journal={IEEE/ACM Transactions on Networking},
volume={14},
number={4},
pages={863--875},
year={2006},
publisher={IEEE}
}

@article{akhbarizadeh2006tcam,
title={{A TCAM-based parallel architecture for high-speed packet forwarding}},
author={Akhbarizadeh, Mohammad J and Nourani, Mehrdad and Panigrahy, Rina and Sharma, Samar},
journal={IEEE Transactions on Computers},
volume={56},
number={1},
pages={58--72},
year={2006}
}

@article{ravikumar2004tcam,
title={{TCAM architecture for IP lookup using prefix properties}},
author={Ravikumar, VC and Mahapatra, Rabi N},
journal={IEEE Micro},
volume={24},
number={2},
pages={60--69},
year={2004}
}
 
#Hash

@inproceedings{kaxiras2005ipstash,
title={{IPStash: a set-associative memory approach for efficient IP-lookup}},
author={Kaxiras, Stefanos and Keramidas, Georgios},
booktitle={IEEE INFOCOM},
volume={2},
pages={992--1001},
year={2005}
}


@inproceedings{bando2009flashlook,
title={{FlashLook: 100-gbps hash-tuned route lookup architecture}},
author={Bando, Masanori and Artan, N Sertac and Chao, H Jonathan},
booktitle={IEEE HPSR},
pages={1--8},
year={2009}
}
 
@inproceedings{hanna2009progressive,
title={Progressive hashing for packet processing using set associative memory},
author={Hanna, Michel and Demetriades, Socrates and Cho, Sangyeun and Melhem, Rami},
booktitle={ACM/IEEE ANCS},
pages={153--162},
year={2009}
}




#Bloom filter

@inproceedings{dharmapurikar2003longest,
title={Longest prefix matching using bloom filters},
author={Dharmapurikar, Sarang and Krishnamurthy, Praveen and Taylor, David E},
booktitle={ACM SIGCOMM},
pages={201--212},
year={2003}
}


@inproceedings{song2009ipv6,
title={{Ipv6 lookups using distributed and load balanced bloom filters for 100Gbps core router line cards}},
author={Song, Haoyu and Hao, Fang and Kodialam, Murali and Lakshman, TV},
booktitle={IEEE INFOCOM},
pages={2518--2526},
year={2009}
}

@article{song2005fast,
title={{Fast hash table lookup using extended bloom filter: an aid to network processing}},
author={Song, Haoyu and Dharmapurikar, Sarang and Turner, Jonathan and Lockwood, John},
journal={ACM SIGCOMM Computer Communication Review},
volume={35},
number={4},
pages={181--192},
year={2005}
}

@inproceedings{hasan2006chisel,
title={{Chisel: A storage-efficient, collision-free hash-based network processing architecture}},
author={Hasan, Jahangir and Cadambi, Srihari and Jakkula, Venkatta and Chakradhar, Srimat},
booktitle={ACM/IEEE ISCA},
pages={203--215},
year={2006}
}
 
#pipelined ASIC

@article{basu2005fast,
title={{Fast incremental updates for pipelined forwarding engines}},
author={Basu, Anindya and Narlikar, Girija},
journal={IEEE/ACM Transactions on Networking},
volume={13},
number={3},
pages={690--703},
year={2005}
}
  
@inproceedings{basu2003fast,
title={{Fast incremental updates for pipelined forwarding engines}},
author={Basu, Anindya and Narlikar, Girija},
booktitle={IEEE INFOCOM},
pages={64--74},
year={2003}
}

@inproceedings{jiang2008beyond,
title={{Beyond TCAMs: An SRAM-based parallel multi-pipeline architecture for terabit IP lookup}},
author={Jiang, Weirong and Wang, Qingbo and Prasanna, Viktor K},
booktitle={IEEE INFOCOM},
pages={1786--1794},
year={2008}
}

@article{jiang2012data,
title={{Data structure optimization for power-efficient ip lookup architectures}},
author={Jiang, Weirong and Prasanna, Viktor K},
journal={IEEE Transactions on Computers},
volume={62},
number={11},
pages={2169--2182},
year={2012}
}
 
@inproceedings{kumar2006camp,
title={{CAMP: fast and efficient IP lookup architecture}},
author={Kumar, Sailesh and Becchi, Michela and Crowley, Patrick and Turner, Jonathan},
booktitle={ACM/IEEE ANCS},
pages={51--60},
year={2006}
}

@inproceedings{hasan2005dynamic,
title={{Dynamic pipelining: making IP-lookup truly scalable}},
author={Hasan, Jahangir and Vijaykumar, TN},
booktitle={ACM SIGCOMM},
volume={35},
number={4},
pages={205--216},
year={2005}
}

@inproceedings{baboescu2005tree,
title={{A tree based router search engine architecture with single port memories}},
author={Baboescu, Florin and Tullsen, Dean M and Rosu, Grigore and Singh, Sumeet},
booktitle={ACM/IEEE ISCA},
pages={123--133},
year={2005}
}

#GPU

@article{han2011packetshader,
title={PacketShader: a GPU-accelerated software router},
author={Han, Sangjin and Jang, Keon and Park, KyoungSoo and Moon, Sue},
journal={ACM SIGCOMM},
volume={41},
number={4},
pages={195--206},
year={2011}
}
  
@inproceedings{li2013gamt,
title={{GAMT: a fast and scalable IP lookup engine for GPU-based software routers}},
author={Li, Yanbiao and Zhang, Dafang and Liu, Alex X and Zheng, Jintao},
booktitle={ACM/IEEE ANCS},
pages={1--12},
year={2013}
} 
 
@inproceedings{sun2013fast,
title={Fast and flexible: parallel packet processing with GPUs and click},
author={Sun, Weibin and Ricci, Robert},
booktitle={ACM/IEEE ANCS},
pages={25--36},
year={2013}
}
 

#Direct lookup

@inproceedings{gupta1998routing,
title={Routing lookups in hardware at memory access speeds},
author={Gupta, Pankaj and Lin, Steven and McKeown, Nick},
booktitle={IEEE INFOCOM},
volume={3},
pages={1240--1247},
year={1998}
}

#Bitmap

@article{degermark1997small,
title={Small forwarding tables for fast routing lookups},
author={Degermark, Mikael and Brodnik, Andrej and Carlsson, Svante and Pink, Stephen},
journal={ACM SIGCOMM},
volume={27},
number={4},
year={1997}
}
   
@inproceedings{srinivasan1998faster,
title={{Faster IP lookups using controlled prefix expansion}},
author={Srinivasan, Venkatachary and Varghese, George},
booktitle={ACM SIGMETRICS},
volume={26},
number={1},
pages={1--10},
year={1998}
} 
 
@inproceedings{song2005shape,
title={{Shape shifting tries for faster IP route lookup}},
author={Song, Haoyu and Turner, Jonathan and Lockwood, John},
booktitle={IEEE ICNP},
pages={10--pp},
year={2005}
}
 
@inproceedings{jacobson1989space,
title={{Space-efficient static trees and graphs}},
author={Jacobson, Guy},
booktitle={IEEE Annual Symposium on Foundations of Computer Science},
pages={549--554},
year={1989}
}
 
 
@article{eatherton2004tree,
title={{Tree bitmap: hardware/software IP lookups with incremental updates}},
author={Eatherton, Will and Varghese, George and Dittia, Zubin},
journal={ACM SIGCOMM Computer Communication Review},
volume={34},
number={2},
pages={97--122},
year={2004},
}

@article{bando2012flashtrie,
title={{FlashTrie: beyond 100-Gb/s IP route lookup using hash-based prefix-compressed trie}},
author={Bando, Masanori and Lin, Yi-Li and Chao, H Jonathan},
journal={IEEE/ACM Transactions On Networking},
volume={20},
number={4},
pages={1262--1275},
year={2012}
}
  
@inproceedings{bando2010flashtrie,
title={{FlashTrie: Hash-based prefix-compressed trie for IP route lookup beyond 100Gbps}},
author={Bando, Masanori and Chao, H Jonathan},
booktitle={IEEE INFOCOM},
pages={1--9},
year={2010}
}

@article{lara2010industry,
title={{Industry's Highest Bandwidth FPGA Enables World's First Single-FPGA Solution for 400G Communications Line Cards}},
author={Lara, Greg},
journal={Xilinx White Paper: Vertex-7 Family},
year={2010}
}

@article{schreiber2002pico,
title={{PICO-NPA: High-level synthesis of nonprogrammable hardware accelerators}},
author={Schreiber, Robert and Aditya, Shail and Mahlke, Scott and Kathail, Vinod and Rau, B Ramakrishna and Cronquist, Darren and Sivaraman, Mukund},
journal={Journal of VLSI signal processing systems for signal, image and video technology},
volume={31},
number={2},
pages={127--142},
year={2002},
publisher={Springer}
}

@inproceedings{kondratyev2013share,
title={{Share with care: A quantitative evaluation of sharing approaches in high-level synthesis}},
author={Kondratyev, Alex and Lavagno, Luciano and Meyer, Mike and Watanabe, Yosinori},
booktitle={IEEE DATE},
pages={1547--1552},
year={2013}
}

@inproceedings{sanguinetti2012transaction,
title={{Transaction-accurate interface scheduling in high-level synthesis}},
author={Sanguinetti, John and Meredith, Michael and Dart, Sean},
booktitle={2012 Electronic System Level Synthesis Conference},
pages={31--36},
year={2012},
organization={IEEE}
}

@inproceedings{song2015scalable,
title={{Scalable name-based packet forwarding: From millions to billions}},
author={Song, Tian and Yuan, Haowei and Crowley, Patrick and Zhang, Beichuan},
booktitle={ACM ICN},
pages={19--28},
year={2015}
}

@article{zhang2014named,
title={{Named data networking}},
author={Zhang, Lixia and Afanasyev, Alexander and Burke, Jeffrey and Jacobson, Van and Claffy, KC and Crowley, Patrick and Papadopoulos, Christos and Wang, Lan and Zhang, Beichuan},
journal={ACM SIGCOMM Computer Communication Review},
volume={44},
number={3},
pages={66--73},
year={2014},
publisher={ACM New York, NY, USA}
}